c***********************************************************************
      subroutine nacute(bthresh)
c***********************************************************************
c     In pixels where the magnitude of the transverse field is below a *
c     given threshold, resolve the 180 degree ambiguity by picking the *
c     direction closest to the direction of the field at a neighboring *
c     pixel. The neighboring pixel is selected to be the one with the  *
c     largest magnitude of the transverse field.                       *
c***********************************************************************
      include "include_file.sizes.f"
      include "include_file.bobs.f"
      include "include_file.point.f"
c-----------------------------------------------------------------------
      dimension bt1d(nxmax*nymax),ba1d(nxmax*nymax),indx(nxmax*nymax)
      dimension imap(nxmax*nymax)
      equivalence(bt,bt1d)
      equivalence(ba,ba1d)
      data pi/3.1415926535897932/
c-----------------------------------------------------------------------
c --> Create an index array for pixels sorted on transverse field.

      call indexx(nxmax*nymax,-bt1d,indx)

c --> Create an array containing the index of the pixel uphill from the
c --> present pixel. 

      call upmap(bt1d,nx,ny,imap)

c --> This is a local test, so loop over pixels and apply at each one. 

      nflip=0
      do 2 i=1,nx*ny
         j=indx(i)

c --> 2-d indices for this pixel.
         jy=1+indx(i)/nxmax
         ix=indx(i)-(jy-1)*nymax
c         if(bt(ix,jy).ne.bt1d(indx(i))) stop '*** indexing wrong ***'

c --> Only apply to points below threshold.

c         if(bt(ix,jy).le.bthresh) then
         if(bt1d(j).le.bthresh) then

c --> Compute dot product of transverse field at this pixel with
c --> transverse field at the neighboring pixel with the largest
c --> transverse field. 
c      write(*,*) i,j,imap(j)
c      write(*,*) bt1d(j),bt1d(imap(j))
c      write(*,*) ba1d(j),ba1d(imap(j))
            bdotb=cos(ba1d(j)-ba1d(imap(j)))
      if(abs(124-ix).le.2.and.abs(170-jy).le.2) then
         write(*,*) ix,jy,imap(j)
         write(*,*) bt1d(j),bt1d(imap(j))
         write(*,*) ba1d(j),ba1d(imap(j))
         write(*,*) bdotb
      endif

c --> Flip direction of transverse field if dot product is negative. 
            if(bdotb.lt.0.) then
               nflip=nflip+1
               if(ba1d(j).lt.0.) then
                  ba1d(j)=ba1d(j)+pi
               else
                  ba1d(j)=ba1d(j)-pi
               endif
            endif
      if(bt1d(j).eq.283.366) then
         write(*,*) 'bad pixel'
         write(*,*) bdotb,ba1d(j),ba1d(imap(j))
      endif

         endif

    1    continue
    2 continue
      write(*,*) 'number of flips',nflip
      write(*,*) 'fraction flipped',float(nflip)/float(nx*ny)

      return
      end
